//ページアクションアイコン
chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab){
  if(/^https?:\/\/pc-play\.games\.dmm\.com\/play\/tohken\/?$/.test(tab.url)){
    chrome.action.enable(tabId);//chrome.pageAction.show(tabId);※V2to3
  }else{chrome.action.disable(tabId);}
});


chrome.runtime.onMessage.addListener(function(request, sender){
  //console.log(request,sender.tab);
  //ミュートpopからとページから
  if(request=="MTflagP"){
    chrome.tabs.query({active:true, currentWindow:true}, function(tabs){
      if(tabs[0].mutedInfo.muted){chrome.tabs.update(tabs[0].id,{muted:false});}
      else{chrome.tabs.update(tabs[0].id,{muted:true});}
    });
  }
  else if(request=="MTflag"){
    if(sender.tab.mutedInfo.muted){chrome.tabs.update(sender.tab.id,{muted:false});}
    else{chrome.tabs.update(sender.tab.id,{muted:true});}
  }
  
  //スクショpopからとページから
  else if(request=="SCflagP"){
    chrome.tabs.create({url:"canvas.html",active:false});
  }
  else if(request=="SCflag"){
    chrome.tabs.create({url:"canvas.html",active:false});
    chrome.windows.update(sender.tab.windowId,{focused:true});
  }
  else if(request.mode=="canvasok"){
    chrome.tabs.query({url:"*://pc-play.games.dmm.com/play/tohken*", currentWindow:true}, function(tabs){
      chrome.tabs.captureVisibleTab({format:"png"},function(dataurl){
        //chrome.tabs.getZoom(tabs[0].id, function(zlv){console.log(zlv);});
        chrome.tabs.sendMessage(tabs[0].id,"SCsize", function(responce){ //座標ゲット
          if(responce){
            var scx=Math.round(responce.x);var scy=Math.round(responce.y);
            chrome.tabs.sendMessage(sender.tab.id,{img:dataurl,sx:scx,sy:scy});
          }else{
            chrome.tabs.sendMessage(sender.tab.id,{img:dataurl,err:true});
          }
          chrome.windows.update(sender.tab.windowId,{focused:true});
          chrome.tabs.update(sender.tab.id,{active:true});          
        });
      });
    });
  }
  
  /*窓変換*/
  else if(request=="WINflag"){
    chrome.windows.get(sender.tab.windowId,function(win){
      if(win.type=="normal"){
        chrome.storage.sync.get(['winposi'], function(items){
          if(items.winposi){
            var winJ = items.winposi;
            if(typeof winJ === "string"){winJ = JSON.parse(winJ);}//★移行措置
            var tempzoom = (winJ.z) ? (winJ.z):1;//移行措置
            chrome.windows.create({width:winJ.w,height:winJ.h,top:winJ.t,left:winJ.l,tabId:sender.tab.id,type:"popup"});
            chrome.tabs.setZoom(sender.tab.id,tempzoom);
          }else{
            chrome.windows.create({width:1178,height:724,tabId:sender.tab.id,type:"popup"});
            chrome.tabs.setZoom(sender.tab.id,1.0);
          }
        });
      }else{
        chrome.windows.create({tabId:sender.tab.id,type:"normal"});
      }
      chrome.tabs.sendMessage(sender.tab.id,{wint:win.type});
    });
  }
	
	/*窓サイズ*/
  else if(request.flag=="RESIZE"){
    chrome.windows.get(sender.tab.windowId,function(win){
      var stname='winposi';var defw=1178;var defh=724;var defz=1.0;//1
      if(request.setno=="2"){stname='winposi2';defw=1410;defh=862;defz=1.2;}
      if(request.setno=="3"){stname='winposi3';defw=952;defh=587;defz=0.8;}
      
      chrome.storage.sync.get([stname], function(items){
        if(items[stname]){
          var winJ = items[stname];
          if(typeof winJ === "string"){winJ = JSON.parse(winJ);}//★移行措置
          if(winJ.z){defz=winJ.z;}//移行中措置
          if(win.type=="popup"){chrome.windows.update(sender.tab.windowId,{width:winJ.w,height:winJ.h,top:winJ.t,left:winJ.l});}
          chrome.tabs.setZoom(sender.tab.id,defz);
        }else{
          if(win.type=="popup"){chrome.windows.update(sender.tab.windowId,{width:defw,height:defh});}
          chrome.tabs.setZoom(sender.tab.id,defz);
        }
      });
    });
  }

  /*変倍*/
  else if(request.flag=="ZOOMCHANGE"){
    chrome.windows.get(sender.tab.windowId,function(win){
      chrome.tabs.getZoom(sender.tab.id,function(nowzoom){
        console.log(nowzoom);
        var defw=1178;var defh=724;var defz=1.0;//1
      if(request.setno=="1"){defw=607;defh=381;defz=0.5;}
      else if(request.setno=="2"){defw=728;defh=451;defz=0.6;}
      else if(request.setno=="3"){defw=952;defh=587;defz=0.8;}
      else if(request.setno=="4"){defw=1410;defh=862;defz=1.2;}
      else if(request.setno=="5"){defw=1758;defh=1045;defz=1.5;}
        
        if(win.type=="popup"){chrome.windows.update(sender.tab.windowId,{width:defw,height:defh});}
        chrome.tabs.setZoom(sender.tab.id,defz);
      });
    });
  }
  //else if(request.flag=="DOWNTXT"){
  //  chrome.tabs.query({url:"chrome-extension://*/downtxt.html", currentWindow:true}, function(tabs){
  //    chrome.tabs.sendMessage(tabs[0].id,request.mes);
  //  });
  //}
	return true;
});

//アラーム
chrome.alarms.onAlarm.addListener(function(alarm){
  if(alarm){
    var t_title = "遠征終了";
    var t_msessage = "部隊が帰還しました";
    if(alarm.name){
      var timer_cat = alarm.name.charAt(0);
      var timer_num = alarm.name.charAt(1);
      if(timer_cat=="e"){t_msessage = "第"+timer_num+t_msessage;}
      else if(timer_cat=="t"){t_title = "鍛刀終了";t_msessage = "鍛錬所"+timer_num+"の鍛刀が終了しました";}
      else if(timer_cat=="r"){t_title = "手入終了";t_msessage = "手入部屋"+timer_num+"の手入が終了しました";}
      else if(alarm.name=="u1"){t_title = "内番終了";t_msessage = "内番が終了しました";}
      else if(alarm.name=="s2"){t_title = "修行帰還";t_msessage = "修行中の刀剣が帰還しました";}
      
      if(alarm.name=="s1"){chrome.alarms.clear("s1");}
      else{
        chrome.notifications.create(alarm.name,{
          type: 'basic',
          iconUrl: '/saniwanote48.png',
          title: t_title,
          message: t_msessage,
          requireInteraction: true
        });
        chrome.alarms.clear(alarm.name);
      }
    }
  }
});
chrome.notifications.onClicked.addListener(function(notid){
  chrome.notifications.clear(notid);
});
/* //最前面
  if(request=="OnTopflag"){
    chrome.tabs.query({active:true, currentWindow:true}, function(tabs){
      chrome.windows.get(tabs[0].windowId,function(win){
        console.log(win);
        if(win.alwaysOnTop){chrome.windows.update(win.id,{alwaysOnTop:false});console.log("最前OFF");}
        else{chrome.windows.update(win.id,{alwaysOnTop:true});console.log("最前ON");}
      });
    });
  }

//二重起動防止 実装時はmanifestに→"webNavigation",
chrome.webNavigation.onBeforeNavigate.addListener(function(request){
  if(request.frameId>0)return;
  console.log(request);
  if(/^http:\/\/www\.dmm\.com\/netgame\/social\/\-\/gadgets\/\=\/app_id=825012\/$/.test(request.url)){
    chrome.tabs.query({active:false,currentWindow:true,url:"http://www.dmm.com/netgame/social/-/gadgets/=/app_id=825012/"},function(tabs){
      if(tabs.length>0){
        chrome.tabs.reload(request.tabId,{bypassCache:true});
        alert("既に開かれています");
      }
    });
  }
});
*/